"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parallelLimit = void 0;
const generatee_1 = require("@zodash/generatee");
const queue_1 = require("@zodash/queue");
const next_tick_1 = require("@zodash/next-tick");
// export interface Queue<T> {
//   enqueue(value: T): void;
//   dequeue(): T;
//   size(): number;
//   isEmpty(): boolean;
// }
// const nextTick = (callback: (...args: any) => void, ...args: any) => typeof setImmediate !== 'undefined' ? setImmediate(callback, ...args) : setTimeout(callback, 0, ...args);
// const poll = (queue: Queue<ITask<any>>) => {
//   if (queue.isEmpty()) {
//     nextTick(poll, queue);
//   }
//   const task = queue.dequeue();
//   task((err, result) => {
//     nextTick(poll, queue);
//   });
// };
// const poll = (generators: any) => {
//   if (generators.done()) {
//     nextTick(poll, generators);
//   }
//   const task = generators.next();
//   task((err, result) => {
//     nextTick(poll, generators);
//   });
// };
function parallelLimit(tasks, limit, cb) {
    let running = new queue_1.Queue();
    const generator = generatee_1.generatee(tasks.map((task, index) => ({ task, index })));
    const results = [];
    function done() {
        if (cb) {
            cb(results);
            cb = null;
        }
    }
    function _done(index, err, result) {
        results[index] = err || result;
        running.dequeue();
        // give err and result to next
        next_tick_1.nextTick(poll);
    }
    function poll() {
        const next = generator.next();
        // no rest tasks
        if (next.done) {
            // no running tasks
            if (!running.isEmpty()) {
                return;
            }
            return next_tick_1.nextTick(done);
        }
        const value = next.value;
        running.enqueue(value);
        const { task, index } = value;
        task(function (err, result) {
            _done(index, err, result);
        });
    }
    function setup(limit) {
        for (let i = 0; i < limit; ++i) {
            next_tick_1.nextTick(poll);
        }
    }
    if (!tasks.length) {
        // empty
        return done();
    }
    // setup
    setup(limit);
}
exports.parallelLimit = parallelLimit;
//# sourceMappingURL=parallel-limit.js.map